﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Core.Primitives;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Resources.Appearance;
using System.Diagnostics;
using Infragistics.UltraChart.Core.Layers;

namespace UltraColumnChartLables
{
    public partial class Form1 : Form
    {
        private List<Text> TextList = new List<Text>();
        public Form1()
        {
            InitializeComponent();

            // DataTable for StackChart
            DataTable dt = new DataTable();
            dt.Columns.Add("Period", typeof(string));
            dt.Columns.Add("Values", typeof(decimal));
            dt.Columns.Add("Values1", typeof(decimal));
            dt.Columns.Add("Values2", typeof(decimal));
            dt.Columns.Add("Values3", typeof(decimal));

            dt.Rows.Add("2008", 10, 20, 20, 30);
            dt.Rows.Add("2009", 20, 40, 40, 60);
            dt.Rows.Add("2010", 30, 10, 60, 20);
            dt.Rows.Add("2011", 20, 10, 30, 40);
            dt.Rows.Add("2012", 55, 10, 40, 60);


            DataTable dt2 = new DataTable();
            dt2.Columns.Add("Period", typeof(string));
            dt2.Columns.Add("Values", typeof(decimal));
            dt2.Rows.Add("2008", 15);
            dt2.Rows.Add("2009", 25);
            dt2.Rows.Add("2010", 35);
            dt2.Rows.Add("2011", 25);
            dt2.Rows.Add("2012", 55);


            
            // Declare a composite chart type
            this.ultraChart1.ChartType = ChartType.Composite;

            //Create a chart area
            ChartArea area = new ChartArea();
            this.ultraChart1.CompositeChart.ChartAreas.Add(area);

            AxisItem axisY = new AxisItem();
            axisY.Extent = 50;
            axisY.DataType = AxisDataType.Numeric;
            axisY.OrientationType = AxisNumber.Y_Axis;
            axisY.LineColor = Color.Blue;
            axisY.Labels.Visible = true;
            area.Axes.Add(axisY);


            AxisItem axisX = new AxisItem();
            axisX.DataType = AxisDataType.String;
            axisX.Extent = 80;
            axisX.SetLabelAxisType = Infragistics.UltraChart.Core.Layers.SetLabelAxisType.GroupBySeries;
            axisX.OrientationType = AxisNumber.X_Axis;
            axisX.LineColor = Color.Blue;
            area.Axes.Add(axisX);

            AxisItem axisX2 = new AxisItem();
            axisX2.DataType = AxisDataType.String;
            axisX2.Extent = 80;
            axisX2.OrientationType = AxisNumber.X_Axis;
            axisX2.LineColor = Color.Blue;
            axisX2.SetLabelAxisType = SetLabelAxisType.ContinuousData;
            area.Axes.Add(axisX2);


            ChartLayerAppearance myColumnLayer = new ChartLayerAppearance();
            myColumnLayer.ChartType = ChartType.StackColumnChart;
            myColumnLayer.ChartArea = area;


            NumericSeries series1 = new NumericSeries();
            series1.DataBind(dt, "Values", "Period");
            myColumnLayer.Series.Add(series1);
            ultraChart1.CompositeChart.Series.Add(series1);

            NumericSeries series2 = new NumericSeries();
            series2.DataBind(dt, "Values1", "Period");
            myColumnLayer.Series.Add(series2);
            ultraChart1.CompositeChart.Series.Add(series2);

            NumericSeries series3 = new NumericSeries();
            series3.DataBind(dt, "Values2", "Period");
            myColumnLayer.Series.Add(series3);
            ultraChart1.CompositeChart.Series.Add(series3);

            NumericSeries series4 = new NumericSeries();
            series4.DataBind(dt, "Values3", "Period");
            myColumnLayer.Series.Add(series4);
            ultraChart1.CompositeChart.Series.Add(series4);


            ChartLayerAppearance myColumnLayer2 = new ChartLayerAppearance();
            myColumnLayer2.ChartType = ChartType.LineChart;
            myColumnLayer2.ChartArea = area;


            NumericSeries  seriesA = new NumericSeries();
            seriesA.DataBind(dt2, "Values", "Period");
            seriesA.PEs.Add(new PaintElement(Color.Orange));
            myColumnLayer2.Series.Add(seriesA);
            ultraChart1.CompositeChart.Series.Add(seriesA);


            LineChartAppearance la = new LineChartAppearance();
            la.Thickness = 5;
            myColumnLayer2.ChartTypeAppearance = la;
            

            myColumnLayer.AxisX = axisX;
            myColumnLayer.AxisY = axisY;

            myColumnLayer2.AxisX = axisX2;
            myColumnLayer2.AxisY = axisY;

            myColumnLayer.SwapRowsAndColumns = true;
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer);
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer2);
            
        }

        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            List<Primitive> list = new List<Primitive>();
            foreach (Primitive item in e.SceneGraph)
            {
                Box pl = item as Box;
                if (pl != null && pl.Series != null)
                {
                    pl.rect = new Rectangle(pl.rect.X + 20, pl.rect.Y, pl.rect.Width - 20, pl.rect.Height);
                }

                if (pl != null && pl.Series != null && ((NumericDataPoint)pl.DataPoint).Value != null)
                {
                    Text txt = new Text();
                    txt.SetTextString(((NumericDataPoint)pl.DataPoint).Value.ToString());
                    txt.bounds.Location = new Point(pl.rect.X + (pl.rect.Width / 2 - 5), pl.rect.Y + (pl.rect.Height / 2));
                    list.Add(txt);
                }
            }
        }
    }
}
